import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wjChart from '@mescius/wijmo.chart';
import * as wjAnnotation from '@mescius/wijmo.chart.annotation';
import { getData, getAnnotation } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
// create the chart
let theChart = new wjChart.FlexChart('#theChart', {
bindingX: 'date',
chartType: 'Line',
itemsSource: getData(),
series: [
{
name: 'Sale',
binding: 'sale'
}
]
});
var basicAL = new wjAnnotation.AnnotationLayer(theChart, getAnnotation());
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div id="theChart"></div>
</div>
</body>
</html>
import * as core from '@mescius/wijmo';
export function getAnnotation() {
let data = [
{
"type": "Circle",
"radius": 40,
"offset": { "x": 0, "y": -15 },
"seriesIndex": 0,
"pointIndex": 33,
"content": "DataIndex",
"position": 0,
"attachment": 0,
"tooltip": "This is a circle annotation. </br> radius: 40 </br> pointIndex: 33 </br> attachment: DataIndex",
"style": {
"fill": "#a3d1a7",
"stroke": "#7b9e7e",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Square",
"length": 80,
"offset": { "x": 0, "y": -15 },
"seriesIndex": 0,
"pointIndex": 45,
"content": "DataIndex",
"position": 0,
"attachment": 0,
"tooltip": "This is a square annotation. </br>length: 80 </br> pointIndex: 45 </br> attachment: DataIndex",
"style": {
"fill": "#c4af71",
"stroke": "#918254",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Line",
"content": "Absolute",
"position": 0,
"start": { "x": 50, "y": 150 },
"end": { "x": 350, "y": 300 },
"tooltip": "This is a line annotation. </br> start: { x: 50, y: 150 } end: { x: 350, y: 300 } </br> attachment: Absolute",
"style": {
"fill": "#FE2E2E",
"stroke": "#01A9DB",
"fill-opacity": 2,
"stroke-width": 4,
"stroke-opacity": 1
}
},
{
"type": "Text",
"attachment": 2,
"text": "Relative",
"position": 0,
"point": { "x": 0.55, "y": 0.15 },
"tooltip": "This is a text annotation.</br>point: { x: 0.55, y: 0.15 }</br> attachment: Relative",
"style": { "fill": "#bbbbbb", "font-size": "26px"
}
},
{
"type": "Ellipse",
"content": "Relative",
"position": 0,
"attachment": 2,
"length": 80,
"point": { "x": 0.4, "y": 0.5 },
"seriesIndex": 0,
"pointIndex": 45,
"tooltip": "This is an ellipse annotation.</br>point: { x: 0.4, y: 0.45 }</br> attachment: Relative",
"style": {
"fill": "#f5bc78",
"stroke": "#c2955f",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Rectangle",
"content": "DataCoordinate",
"position": 0,
"attachment": 1,
"point": { "x": "2014-02-10", "y": 30 },
"tooltip": "This is a rectangle annotation.</br>point:{ x: new Date(2014, 1, 10), y: 40 }</br> attachment: DataCoordinate",
"seriesIndex": 0,
"pointIndex": 45,
"style": {
"fill": "#c5aacd",
"stroke": "#937f99",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Image",
"position": 0,
"attachment": 1,
"href": "resources/wijmo5-flexible.png",
"point": { "x": "2014-01-25", "y": 30 },
"tooltip": "This is an image annotation.</br>point:{x: new Date(2014, 0, 25), y: 20}</br> attachment: DataCoordinate",
"style": {
"fill": "#01DFD7",
"stroke": "#000000",
"fill-opacity": 1,
"stroke-width": 1,
"stroke-opacity": 1
}
},
{
"type": "Polygon",
"content": "Absolute",
"position": 0,
"tooltip": "This is a polygon annotation.</br>points: [(200,0),(150,50),(175,100),(255,100),(250, 50)]</br> attachment: Absolute",
"style": {
"fill": "#FE2E2E",
"stroke": "#01A9DB",
"fill-opacity": 2,
"stroke-width": 4,
"stroke-opacity": 1
},
"points": [
{ "x": 200, "y": 0 },
{ "x": 150, "y": 50 },
{ "x": 175, "y": 100 },
{ "x": 225, "y": 100 },
{ "x": 250, "y": 50 }
]
}
];
for (var i = 0; i < data.length; i++) {
if (data[i].attachment === 1 && data[i].point && data[i].point.x && isNaN(data[i].point.x)) {
data[i].point.x = core.Globalize.parseDate(data[i].point.x, 'yyyy-MM-dd');
}
}
return data;
}
//
export function getData() {
var data = [], sales = [
96, 19, 54, 83, 15, 56, 36, 4, 29, 93,
38, 71, 50, 77, 69, 13, 79, 57, 29, 62,
4, 27, 66, 96, 65, 12, 52, 3, 61, 48, 50,
70, 39, 33, 25, 49, 69, 46, 44, 40, 35,
72, 64, 10, 66, 63, 78, 19, 96, 26
];
for (var i = 0; i < 50; i++) {
data.push({
sale: sales[i],
date: new Date(2014, 0, i),
});
}
return data;
}
.wj-flexchart {
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div class="form-group">
<wj-flex-chart :itemsSource="data" chartType="Line" bindingX="date">
<wj-flex-chart-series binding="sale"></wj-flex-chart-series>
<wj-flex-chart-legend position="Left"></wj-flex-chart-legend>
<wj-flex-chart-annotation-layer>
<wj-flex-chart-annotation-circle :radius=40 :offset="{ x: 0, y: -15 }" :seriesIndex=0 :pointIndex=33
content="DataIndex" position="Center" attachment="DataIndex"
tooltip="This is Circle annotation. </br> radius: 40 </br> pointIndex: 33 </br> attachment: DataIndex"
:style="{ 'fill': '#a3d1a7', 'stroke': '#7b9e7e', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-circle>
<wj-flex-chart-annotation-square :length=80 :offset="{ x: 0, y: -15 }" :seriesIndex=0 :pointIndex=45
content="DataIndex" position="Center" attachment="DataIndex"
tooltip="This is square annotation. </br>length: 80 </br> pointIndex: 45 </br> attachment: DataIndex"
:style="{ 'fill': '#c4af71', 'stroke': '#918254', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-square>
<wj-flex-chart-annotation-line content="Absolute" position="Center" :start="{ x: 50, y: 150 }"
:end="{ x: 350, y: 300 }"
tooltip="This is line annotation. </br> start: { x: 50, y: 150 } end: { x: 350, y: 300 } </br> attachment: Absolute"
:style="{ 'fill': '#FE2E2E', 'stroke': '#01A9DB', 'fill-opacity': 2, 'stroke-width': 4, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-line>
<wj-flex-chart-annotation-text attachment="Relative" text="Relative" position="Center"
:point="{ x: 0.55, y: 0.15 }"
tooltip="This is text annotation.</br>point: { x: 0.55, y: 0.15 }</br> attachment: Relative"
:style="{ 'fill': '#bbbbbb', 'font-size': '26px' }"></wj-flex-chart-annotation-text>
<wj-flex-chart-annotation-ellipse content="Relative" position="Center" attachment="Relative"
:point="{ x: 0.4, y: 0.5 }"
tooltip="This is ellipse annotation.</br>point: { x: 0.4, y: 0.45 }</br> attachment: Relative"
:style="{ 'fill': '#f5bc78', 'stroke': '#c2955f', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-ellipse>
<wj-flex-chart-annotation-rectangle content="DataCoordinate" position="Center"
attachment="DataCoordinate" :point="{ x: basic.rectDate, y: 30 }"
tooltip="This is rectangle annotation.</br>point:{ x: new Date(2014, 1, 10), y: 40 }</br> attachment: DataCoordinate"
:style="{ 'fill': '#c5aacd', 'stroke': '#937f99', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-rectangle>
<wj-flex-chart-annotation-image position="Center" attachment="DataCoordinate"
href="resources/wijmo5-flexible.png" :point="{ x: basic.imageDate, y: 30 }"
tooltip="This is image annotation.</br>point:{x: new Date(2014, 0, 25), y: 20}</br> attachment: DataCoordinate"
:style="{ 'fill': '#01DFD7', 'stroke': '#000000', 'fill-opacity': 1, 'stroke-width': 1, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-image>
<wj-flex-chart-annotation-polygon content="Absolute" position="Center"
tooltip="This is polygon annotation.</br>paths: (200,0),(150,50),(175,100),(255,100),(250, 50)</br> attachment: Absolute"
:style="{ 'fill': '#FE2E2E', 'stroke': '#01A9DB', 'fill-opacity': 2, 'stroke-width': 4, 'stroke-opacity': 1 }">
<wj-flex-chart-data-point wjProperty="points" :x="200" :y="0"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" :x="150" :y="50"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" :x="175" :y="100"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" :x="225" :y="100"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" :x="250" :y="50"></wj-flex-chart-data-point>
</wj-flex-chart-annotation-polygon>
</wj-flex-chart-annotation-layer>
</wj-flex-chart>
</div>
</div>
</template>
<script setup>
import { getData } from "./data";
import * as wjChart from "@mescius/wijmo.chart";
import { ref } from "vue";
const data = ref(getData());
const basic = ref({
rectDate: new Date(2014, 1, 10),
imageDate: new Date(2014, 0, 25),
});
</script>
<style>
.container .wj-flexchart {
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import * as core from '@mescius/wijmo';
export function getData() {
var data = [], sales = [
96, 19, 54, 83, 15, 56, 36, 4, 29, 93,
38, 71, 50, 77, 69, 13, 79, 57, 29, 62,
4, 27, 66, 96, 65, 12, 52, 3, 61, 48, 50,
70, 39, 33, 25, 49, 69, 46, 44, 40, 35,
72, 64, 10, 66, 63, 78, 19, 96, 26];
for (var i = 0; i < 50; i++) {
data.push({
sale: sales[i],
date: new Date(2014, 0, i),
});
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import { WjChartAnnotationModule } from '@mescius/wijmo.angular2.chart.annotation';
import { DataService } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjChartModule, WjChartAnnotationModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data: any[];
basic: any;
//
constructor(@Inject(DataService) private dataService: DataService) {
this.data = dataService.getData();
this.basic = {
rectDate: new Date(2014, 1, 10),
imageDate: new Date(2014, 0, 25),
};
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div class="form-group">
<wj-flex-chart [itemsSource]="data" chartType="Line" bindingX="date">
<wj-flex-chart-series binding="sale"></wj-flex-chart-series>
<wj-flex-chart-legend position="Left"></wj-flex-chart-legend>
<wj-flex-chart-annotation-layer control="al">
<wj-flex-chart-annotation-circle [radius]="40" [offset]="{x: 0, y: -15}" [seriesIndex]="0"
[pointIndex]="33" content="DataIndex" position="Center" attachment="DataIndex"
tooltip="This is Circle annotation. </br> radius: 40 </br> pointIndex: 33 </br> attachment: DataIndex"
[style]="{ 'fill': '#a3d1a7', 'stroke': '#7b9e7e', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-circle>
<wj-flex-chart-annotation-square [length]="80" [offset]="{x: 0, y: -15}" [seriesIndex]="0"
[pointIndex]="45" content="DataIndex" position="Center" attachment="DataIndex"
tooltip="This is square annotation. </br>length: 80 </br> pointIndex: 45 </br> attachment: DataIndex"
[style]="{ 'fill': '#c4af71', 'stroke': '#918254', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-square>
<wj-flex-chart-annotation-line content="Absolute" position="Center" [start]="{x: 50, y: 150}" [end]="{x: 350, y: 300}"
tooltip="This is line annotation. </br> start: { x: 50, y: 150 } end: { x: 350, y: 300 } </br> attachment: Absolute"
[style]="{ 'fill': '#FE2E2E', 'stroke': '#01A9DB', 'fill-opacity': 2, 'stroke-width': 4, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-line>
<wj-flex-chart-annotation-text attachment="Relative" text="Relative" position="Center" [point]="{x:0.55, y:0.15}"
tooltip="This is text annotation.</br>point: { x: 0.55, y: 0.15 }</br> attachment: Relative"
[style]="{ 'fill': '#bbbbbb', 'font-size': '26px' }"></wj-flex-chart-annotation-text>
<wj-flex-chart-annotation-ellipse content="Relative" position="Center" attachment="Relative" [point]="{x:0.4,y:0.5}"
tooltip="This is ellipse annotation.</br>point: { x: 0.4, y: 0.45 }</br> attachment: Relative"
[style]="{ 'fill': '#f5bc78', 'stroke': '#c2955f', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-ellipse>
<wj-flex-chart-annotation-rectangle content="DataCoordinate" position="Center" attachment="DataCoordinate" [point]="{x: basic.rectDate, y: 30}"
tooltip="This is rectangle annotation.</br>point:{ x: new Date(2014, 1, 10), y: 40 }</br> attachment: DataCoordinate"
[style]="{ 'fill': '#c5aacd', 'stroke': '#937f99', 'fill-opacity': 1, 'stroke-width': 2, 'stroke-opacity': 1 }"></wj-flex-chart-annotation-rectangle>
<wj-flex-chart-annotation-image position="Center" attachment="DataCoordinate" href="resources/wijmo5-flexible.png" [point]="{x: basic.imageDate, y: 30}"
tooltip="This is image annotation.</br>point:{x: new Date(2014, 0, 25), y: 20}</br> attachment: DataCoordinate"
[style]="{ 'fill': '#01DFD7', 'stroke': '#000000', 'fill-opacity': 1, 'stroke-width': 1, 'stroke-opacity': 1}"></wj-flex-chart-annotation-image>
<wj-flex-chart-annotation-polygon content="Absolute" position="Center"
tooltip="This is polygon annotation.</br>paths: [(200,0),(150,50),(175,100),(255,100),(250, 50)]</br> attachment: Absolute"
[style]="{ 'fill': '#FE2E2E', 'stroke': '#01A9DB', 'fill-opacity': 2, 'stroke-width': 4, 'stroke-opacity': 1 }">
<wj-flex-chart-data-point wjProperty="points" [x]="200" [y]="0"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" [x]="150" [y]="50"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" [x]="175" [y]="100"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" [x]="225" [y]="100"></wj-flex-chart-data-point>
<wj-flex-chart-data-point wjProperty="points" [x]="250" [y]="50"></wj-flex-chart-data-point>
</wj-flex-chart-annotation-polygon>
</wj-flex-chart-annotation-layer>
</wj-flex-chart>
</div>
</div>
import { Injectable } from '@angular/core';
import * as core from '@mescius/wijmo';
//
@Injectable()
export class DataService {
getData() {
var data = [], sales = [
96, 19, 54, 83, 15, 56, 36, 4, 29, 93,
38, 71, 50, 77, 69, 13, 79, 57, 29, 62,
4, 27, 66, 96, 65, 12, 52, 3, 61, 48, 50,
70, 39, 33, 25, 49, 69, 46, 44, 40, 35,
72, 64, 10, 66, 63, 78, 19, 96, 26];
for (var i = 0; i < 50; i++) {
data.push({
sale: sales[i],
date: new Date(2014, 0, i),
});
}
return data;
}
}
.wj-flexchart {
margin: 10px 0;
}
body {
margin-bottom: 24pt;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef } from 'react';
import * as Chart from '@mescius/wijmo.react.chart';
import * as wjAnnotation from '@mescius/wijmo.chart.annotation';
import './app.css';
import { data, annotation } from './data';
function App() {
const annotationLayerRef = useRef(null);
const initializeFlexGrid = (flexChart) => {
annotationLayerRef.current = new wjAnnotation.AnnotationLayer(flexChart, annotation);
};
return (<div className="container">
<div className="form-group">
<Chart.FlexChart initialized={initializeFlexGrid} itemsSource={data} chartType="Line" bindingX="date">
<Chart.FlexChartSeries binding="sale"/>
<Chart.FlexChartLegend position="Left"/>
</Chart.FlexChart>
</div>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexChart Annotations</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.container .wj-flexchart {
margin: 10px 0;
}
import * as core from '@mescius/wijmo';
function getData() {
var data = [], sales = [
96, 19, 54, 83, 15, 56, 36, 4, 29, 93,
38, 71, 50, 77, 69, 13, 79, 57, 29, 62,
4, 27, 66, 96, 65, 12, 52, 3, 61, 48, 50,
70, 39, 33, 25, 49, 69, 46, 44, 40, 35,
72, 64, 10, 66, 63, 78, 19, 96, 26
];
for (var i = 0; i < 50; i++) {
data.push({
sale: sales[i],
date: new Date(2014, 0, i),
});
}
return data;
}
function getAnnotation() {
let data = [
{
"type": "Circle",
"radius": 40,
"offset": { "x": 0, "y": -15 },
"seriesIndex": 0,
"pointIndex": 33,
"content": "DataIndex",
"position": 0,
"attachment": 0,
"tooltip": "This is a circle annotation. </br> radius: 40 </br> pointIndex: 33 </br> attachment: DataIndex",
"style": {
"fill": "#a3d1a7",
"stroke": "#7b9e7e",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Square",
"length": 80,
"offset": { "x": 0, "y": -15 },
"seriesIndex": 0,
"pointIndex": 45,
"content": "DataIndex",
"position": 0,
"attachment": 0,
"tooltip": "This is a square annotation. </br>length: 80 </br> pointIndex: 45 </br> attachment: DataIndex",
"style": {
"fill": "#c4af71",
"stroke": "#918254",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Line",
"content": "Absolute",
"position": 0,
"start": { "x": 50, "y": 150 },
"end": { "x": 350, "y": 300 },
"tooltip": "This is a line annotation. </br> start: { x: 50, y: 150 } end: { x: 350, y: 300 } </br> attachment: Absolute",
"style": {
"fill": "#FE2E2E",
"stroke": "#01A9DB",
"fill-opacity": 2,
"stroke-width": 4,
"stroke-opacity": 1
}
},
{
"type": "Text",
"attachment": 2,
"text": "Relative",
"position": 0,
"point": { "x": 0.55, "y": 0.15 },
"tooltip": "This is a text annotation.</br>point: { x: 0.55, y: 0.15 }</br> attachment: Relative",
"style": {
"fill": "#bbbbbb", "font-size": "26px"
}
},
{
"type": "Ellipse",
"content": "Relative",
"position": 0,
"attachment": 2,
"length": 80,
"point": { "x": 0.4, "y": 0.5 },
"seriesIndex": 0,
"pointIndex": 45,
"tooltip": "This is an ellipse annotation.</br>point: { x: 0.4, y: 0.45 }</br> attachment: Relative",
"style": {
"fill": "#f5bc78",
"stroke": "#c2955f",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Rectangle",
"content": "DataCoordinate",
"position": 0,
"attachment": 1,
"point": { "x": "2014-02-10", "y": 30 },
"tooltip": "This is a rectangle annotation.</br>point:{ x: new Date(2014, 1, 10), y: 40 }</br> attachment: DataCoordinate",
"seriesIndex": 0,
"pointIndex": 45,
"style": {
"fill": "#c5aacd",
"stroke": "#937f99",
"fill-opacity": 1,
"stroke-width": 2,
"stroke-opacity": 1
}
},
{
"type": "Image",
"position": 0,
"attachment": 1,
"href": "resources/wijmo5-flexible.png",
"point": { "x": "2014-01-25", "y": 30 },
"tooltip": "This is an image annotation.</br>point:{x: new Date(2014, 0, 25), y: 20}</br> attachment: DataCoordinate",
"style": {
"fill": "#01DFD7",
"stroke": "#000000",
"fill-opacity": 1,
"stroke-width": 1,
"stroke-opacity": 1
}
},
{
"type": "Polygon",
"content": "Absolute",
"position": 0,
"tooltip": "This is a polygon annotation.</br>points: [(200,0),(150,50),(175,100),(255,100),(250, 50)]</br> attachment: Absolute",
"style": {
"fill": "#FE2E2E",
"stroke": "#01A9DB",
"fill-opacity": 2,
"stroke-width": 4,
"stroke-opacity": 1
},
"points": [
{ "x": 200, "y": 0 },
{ "x": 150, "y": 50 },
{ "x": 175, "y": 100 },
{ "x": 225, "y": 100 },
{ "x": 250, "y": 50 }
]
}
];
for (var i = 0; i < data.length; i++) {
var d = data[i];
if (d.attachment === 1 && d.point && d.point.x && isNaN(d.point.x)) {
(d.point).x = core.Globalize.parseDate(d.point.x, 'yyyy-MM-dd');
}
}
return data;
}
export const data = getData();
export const annotation = getAnnotation();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);